// P_2_1_3_01
//
// Generative Gestaltung – Creative Coding im Web
// ISBN: 978-3-87439-902-9, First Edition, Hermann Schmidt, Mainz, 2018
// Benedikt Groß, Hartmut Bohnacker, Julia Laub, Claudius Lazzeroni
// with contributions by Joey Lee and Niels Poldervaart
// Copyright 2018
//
// http://www.generative-gestaltung.de
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

int count = 0;
int tileCountX = 10;
int tileCountY = 10;
float tileWidth = 0;
float tileHeight = 0;

int colorStep = 15;

int circleCount = 0;
float endSize = 0;
float endOffset = 0;

float actRandomSeed = 0;

void setup() {
  size(800, 800);
  tileWidth = width / tileCountX;
  tileHeight = height / tileCountY;
  noFill();
  stroke(0, 128);
}

void draw() {
  background(255);
  randomSeed(int(actRandomSeed)); // Cast to int
  translate(tileWidth / 2, tileHeight / 2);

  circleCount = int(mouseX / 30) + 1;
  endSize = map(mouseX, 0, max(width, mouseX), tileWidth / 2, 0);
  endOffset = map(mouseY, 0, max(height, mouseY), 0, (tileWidth - endSize) / 2);

  for (int gridY = 0; gridY <= tileCountY; gridY++) {
    for (int gridX = 0; gridX <= tileCountX; gridX++) {
      pushMatrix();
      translate(tileWidth * gridX, tileHeight * gridY);
      scale(1, tileHeight / tileWidth);

      int toggle = int(random(0, 4));
      if (toggle == 0) rotate(-HALF_PI);
      if (toggle == 1) rotate(0);
      if (toggle == 2) rotate(HALF_PI);
      if (toggle == 3) rotate(PI);

      // draw module
      for (int i = 0; i < circleCount; i++) {
        float diameter = map(i, 0, circleCount, tileWidth, endSize);
        float offset = map(i, 0, circleCount, 0, endOffset);
        ellipse(offset, 0, diameter, diameter);
      }
      popMatrix();
    }
  }
}

void mousePressed() {
  actRandomSeed = random(100000);
}

//void keyReleased() {
//  if (key == 's' || key == 'S') {
//    saveFrame(gd.timestamp() + ".png");
//  }
//}
